//Copyright © 2015, Oracle and/or its affiliates. All rights reserved.

package resource;

import java.util.Date;
import java.util.LinkedList;
import java.util.List;



import util.OEPEUtil;


public class Employee {
	
	public static class Employees {
		private List<Employee> employees;

		public Employees() {
			// Default constructor
		}

		public Employees(Iterable<? extends Employee> employees) {
			this.employees = OEPEUtil.toList(employees);
		}

		public void setEmployees(List<Employee> employees) {
			this.employees = employees;
		}

	
		public List<Employee> getEmployees() {
			return employees == null ? employees = new LinkedList<>() : employees;
		}
	}

    private static final long serialVersionUID = -3955231169170050659L;
    
    private Double commissionPct;  
    private String email;
    private Integer employeeId;
    private String firstName;
    private Date hireDate;
    private String jobId;
    private String lastName;
    private Integer managerId;
    private String phoneNumber;
    private Integer salary;
    private Integer departmentId;
    private Department department;
    
	public Employee() {
		super();
	}
	 
	public Employee(Integer employeeId, String firstName, String lastName,
			 String email, String phoneNumber, String hireDate,String jobId, Integer salary,
			Double commissionPct,  Integer managerId, Integer departmentId) {
		super();
		this.employeeId = employeeId;
		this.firstName = firstName;
		this.lastName = lastName;
		this.phoneNumber = phoneNumber;
		this.email = email;
		//this.hireDate = hireDate;
		this.salary = salary;
		this.commissionPct = commissionPct;
		this.jobId = jobId;
		this.managerId = managerId;
		this.departmentId = departmentId;
	}
	
	public Employee (Employee employee) {
		super();
		this.update(employee);
	
	}

	public Double getCommissionPct() {
		return commissionPct;
	}

	public void setCommissionPct(Double commissionPct) {
		this.commissionPct = commissionPct;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public Integer getEmployeeId() {
		return employeeId;
	}
	public void setEmployeeId(Integer employeeId) {
		this.employeeId = employeeId;
	}
	public String getFirstName() {
		return firstName;
	}
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	public Date getHireDate() {
		return hireDate;
	}
	public void setHireDate(Date hireDate) {
		this.hireDate = hireDate;
	}
	public String getJobId() {
		return jobId;
	}
	public void setJobId(String jobId) {
		this.jobId = jobId;
	}
	public String getLastName() {
		return lastName;
	}
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	public Integer getManagerId() {
		return managerId;
	}
	public void setManagerId(Integer managerId) {
		this.managerId = managerId;
	}
	public String getPhoneNumber() {
		return phoneNumber;
	}
	public void setPhoneNumber(String phoneNumber) {
		this.phoneNumber = phoneNumber;
	}
	public Integer getSalary() {
		return salary;
	}
	public void setSalary(Integer salary) {
		this.salary = salary;
	}
	public static long getSerialversionuid() {
		return serialVersionUID;
	}
    
    public Integer getDepartmentId() {
		return departmentId;
	}

	public void setDepartmentId(Integer departmentId) {
		this.departmentId = departmentId;
	}

	public Department getDepartment() {
        return department;
    }

    public void setDepartment(Department department) {
        this.department = department;
    }
    
    public void update (Employee employee) {
    	this.employeeId = employee.getEmployeeId();
		this.firstName = employee.getFirstName();
		this.lastName = employee.getLastName();
		this.phoneNumber = employee.getPhoneNumber();
		this.email = employee.getEmail();
		//this.hireDate = employee.getHireDate();
		this.salary = employee.getSalary();
		this.commissionPct = employee.getCommissionPct();
		this.jobId = employee.getJobId();
		this.managerId = employee.getManagerId();
		this.departmentId = employee.getDepartmentId();
    	
    }
    
}
