//Copyright © 2015, Oracle and/or its affiliates. All rights reserved.

package resource;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;

/*import jersey.repackaged.com.google.common.collect.Multimap;
import jersey.repackaged.com.google.common.collect.ArrayListMultimap;*/



public final class HRMockDB {

	public static final HRMockDB INSTANCE = new HRMockDB();

	
	private final ConcurrentMap<Integer, Employee> employees = new ConcurrentHashMap<>();
	/*private final Multimap<Integer, Employee> departmentEmployees = ArrayListMultimap.create();*/
	private final Map<Integer, List<Employee>> departmentEmployees = new HashMap<Integer, List<Employee>>();
	private final ConcurrentMap<Integer, Department> departments = new ConcurrentHashMap<>();

	private HRMockDB() {
		try {
			populateEmployees();
			populateDepartments();
			populateDepartmentEmployees();
		} 
		catch (Exception e) {
			e.printStackTrace();
		}
	
	}

	//Manage Employee
	private void populateEmployees() throws Exception {
		Employee emp;
		//Integer employeeId, String firstName, String lastName, String email, String phoneNumber, String hireDate,String jobId, Integer salary,	Integer commissionPct,  Integer managerId, Integer departmentId
		emp = new Employee (777,"John","Smith","JSMITH","333-222-4444","2005-09-28 00:00:00.0","FI_ACCOUNT",8200,0D,0,0 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (888,"John","Smith","RAGHUSRI","333-222-4444","2005-09-28 00:00:00.0","FI_ACCOUNT",8200,0D,0,0 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (800,"Joe","Doe","jdoe","510-222-4444","2005-09-28 00:00:00.0","FI_ACCOUNT",8200,0D,0,0 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (1234,"R","S","r.s@o.com","1234567890","0006-07-08 00:00:00.0","FI_ACCOUNT",12345,0D,0,0 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (100,"Steven","King","SKING","515.123.4567","2003-06-17 00:00:00.0","AD_PRES",24000,0D,0,90 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (101,"Neena","Kochhar","NKOCHHAR","515.123.4568","2005-09-21 00:00:00.0","AD_VP",17000,0D,100,90 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (102,"Lex","De Haan","LDEHAAN","515.123.4569","2001-01-13 00:00:00.0","AD_VP",17000,0D,100,90 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (103,"Alexander","Hunold","AHUNOLD","590.423.4567","2006-01-03 00:00:00.0","IT_PROG",9000,0D,102,60 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (104,"Bruce","Ernst","BERNST","590.423.4568","2007-05-21 00:00:00.0","IT_PROG",6000,0D,103,60 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (105,"David","Austin","DAUSTIN","590.423.4569","2005-06-25 00:00:00.0","IT_PROG",4800,0D,103,60 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (106,"Valli","Pataballa","VPATABAL","590.423.4560","2006-02-05 00:00:00.0","IT_PROG",4800,0D,103,60 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (107,"Diana","Lorentz","DLORENTZ","590.423.5567","2007-02-07 00:00:00.0","IT_PROG",4200,0D,103,60 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (108,"Nancy","Greenberg","NGREENBE","515.124.4569","2002-08-17 00:00:00.0","FI_MGR",12008,0D,101,100 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (109,"Daniel","Faviet","DFAVIET","515.124.4169","2002-08-16 00:00:00.0","FI_ACCOUNT",9000,0D,108,100 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (110,"John","Chen","JCHEN","515.124.4269","2005-09-28 00:00:00.0","FI_ACCOUNT",8200,0D,108,100 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (111,"Ismael","Sciarra","ISCIARRA","515.124.4369","2005-09-30 00:00:00.0","FI_ACCOUNT",7700,0D,108,100 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (112,"Jose Manuel","Urman","JMURMAN","515.124.4469","2006-03-07 00:00:00.0","FI_ACCOUNT",7800,0D,108,100 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (113,"Luis","Popp","LPOPP","515.124.4567","2007-12-07 00:00:00.0","FI_ACCOUNT",6900,0D,108,100 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (114,"Den","Raphaely","DRAPHEAL","515.127.4561","2002-12-07 00:00:00.0","PU_MAN",11000,0D,100,30 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (115,"Alexander","Khoo","AKHOO","515.127.4562","2003-05-18 00:00:00.0","PU_CLERK",3100,0D,114,30 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (116,"Shelli","Baida","SBAIDA","515.127.4563","2005-12-24 00:00:00.0","PU_CLERK",2900,0D,114,30 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (117,"Sigal","Tobias","STOBIAS","515.127.4564","2005-07-24 00:00:00.0","PU_CLERK",2800,0D,114,30 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (118,"Guy","Himuro","GHIMURO","515.127.4565","2006-11-15 00:00:00.0","PU_CLERK",2600,0D,114,30 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (119,"Karen","Colmenares","KCOLMENA","515.127.4566","2007-08-10 00:00:00.0","PU_CLERK",2500,0D,114,30 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (120,"Matthew","Weiss","MWEISS","650.123.1234","2004-07-18 00:00:00.0","ST_MAN",8000,0D,100,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (121,"Adam","Fripp","AFRIPP","650.123.2234","2005-04-10 00:00:00.0","ST_MAN",8200,0D,100,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (122,"Payam","Kaufling","PKAUFLIN","650.123.3234","2003-05-01 00:00:00.0","ST_MAN",7900,0D,100,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (123,"Shanta","Vollman","SVOLLMAN","650.123.4234","2005-10-10 00:00:00.0","ST_MAN",6500,0D,100,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (124,"Kevin","Mourgos","KMOURGOS","650.123.5234","2007-11-16 00:00:00.0","ST_MAN",5800,0D,100,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (125,"Julia","Nayer","JNAYER","650.124.1214","2005-07-16 00:00:00.0","ST_CLERK",3200,0D,120,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (126,"Irene","Mikkilineni","IMIKKILI","650.124.1224","2006-09-28 00:00:00.0","ST_CLERK",2700,0D,120,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (127,"James","Landry","JLANDRY","650.124.1334","2007-01-14 00:00:00.0","ST_CLERK",2400,0D,120,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (128,"Steven","Markle","SMARKLE","650.124.1434","2008-03-08 00:00:00.0","ST_CLERK",2200,0D,120,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (129,"Laura","Bissot","LBISSOT","650.124.5234","2005-08-20 00:00:00.0","ST_CLERK",3300,0D,121,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (130,"Mozhe","Atkinson","MATKINSO","650.124.6234","2005-10-30 00:00:00.0","ST_CLERK",2800,0D,121,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (131,"James","Marlow","JAMRLOW","650.124.7234","2005-02-16 00:00:00.0","ST_CLERK",2500,0D,121,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (132,"TJ","Olson","TJOLSON","650.124.8234","2007-04-10 00:00:00.0","ST_CLERK",2100,0D,121,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (133,"Jason","Mallin","JMALLIN","650.127.1934","2004-06-14 00:00:00.0","ST_CLERK",3300,0D,122,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (134,"Michael","Rogers","MROGERS","650.127.1834","2006-08-26 00:00:00.0","ST_CLERK",2900,0D,122,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (135,"Ki","Gee","KGEE","650.127.1734","2007-12-12 00:00:00.0","ST_CLERK",2400,0D,122,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (136,"Hazel","Philtanker","HPHILTAN","650.127.1634","2008-02-06 00:00:00.0","ST_CLERK",2200,0D,122,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (137,"Renske","Ladwig","RLADWIG","650.121.1234","2003-07-14 00:00:00.0","ST_CLERK",3600,0D,123,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (138,"Stephen","Stiles","SSTILES","650.121.2034","2005-10-26 00:00:00.0","ST_CLERK",3200,0D,123,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (139,"John","Seo","JSEO","650.121.2019","2006-02-12 00:00:00.0","ST_CLERK",2700,0D,123,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (140,"Joshua","Patel","JPATEL","650.121.1834","2006-04-06 00:00:00.0","ST_CLERK",2500,0D,123,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (141,"Trenna","Rajs","TRAJS","650.121.8009","2003-10-17 00:00:00.0","ST_CLERK",3500,0D,124,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (142,"Curtis","Davies","CDAVIES","650.121.2994","2005-01-29 00:00:00.0","ST_CLERK",3100,0D,124,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (143,"Randall","Matos","RMATOS","650.121.2874","2006-03-15 00:00:00.0","ST_CLERK",2600,0D,124,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (144,"Peter","Vargas","PVARGAS","650.121.2004","2006-07-09 00:00:00.0","ST_CLERK",2500,0D,124,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (145,"John","Russell","JRUSSEL","011.44.1344.429268","2004-10-01 00:00:00.0","SA_MAN",14000,0.4,100,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (146,"Karen","Partners","KPARTNER","011.44.1344.467268","2005-01-05 00:00:00.0","SA_MAN",13500,0.3,100,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (147,"Alberto","Errazuriz","AERRAZUR","011.44.1344.429278","2005-03-10 00:00:00.0","SA_MAN",12000,0.3,100,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (148,"Gerald","Cambrault","GCAMBRAU","011.44.1344.619268","2007-10-15 00:00:00.0","SA_MAN",11000,0.3,100,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (149,"Eleni","Zlotkey","EZLOTKEY","011.44.1344.429018","2008-01-29 00:00:00.0","SA_MAN",10500,0.2,100,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (150,"Peter","Tucker","PTUCKER","011.44.1344.129268","2005-01-30 00:00:00.0","SA_REP",10000,0.3,145,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (151,"David","Bernstein","DBERNSTE","011.44.1344.345268","2005-03-24 00:00:00.0","SA_REP",9500,0.25,145,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (152,"Peter","Hall","PHALL","011.44.1344.478968","2005-08-20 00:00:00.0","SA_REP",9000,0.25,145,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (153,"Christopher","Olsen","COLSEN","011.44.1344.498718","2006-03-30 00:00:00.0","SA_REP",8000,0.2,145,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (154,"Nanette","Cambrault","NCAMBRAU","011.44.1344.987668","2006-12-09 00:00:00.0","SA_REP",7500,0.2,145,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (155,"Oliver","Tuvault","OTUVAULT","011.44.1344.486508","2007-11-23 00:00:00.0","SA_REP",7000,0.15,145,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (156,"Janette","King","JKING","011.44.1345.429268","2004-01-30 00:00:00.0","SA_REP",10000,0.35,146,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (157,"Patrick","Sully","PSULLY","011.44.1345.929268","2004-03-04 00:00:00.0","SA_REP",9500,0.35,146,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (158,"Allan","McEwen","AMCEWEN","011.44.1345.829268","2004-08-01 00:00:00.0","SA_REP",9000,0.35,146,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (159,"Lindsey","Smith","LSMITH","011.44.1345.729268","2005-03-10 00:00:00.0","SA_REP",8000,0.3,146,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (160,"Louise","Doran","LDORAN","011.44.1345.629268","2005-12-15 00:00:00.0","SA_REP",7500,0.3,146,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (161,"Sarath","Sewall","SSEWALL","011.44.1345.529268","2006-11-03 00:00:00.0","SA_REP",7000,0.25,146,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (162,"Clara","Vishney","CVISHNEY","011.44.1346.129268","2005-11-11 00:00:00.0","SA_REP",10500,0.25,147,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (163,"Danielle","Greene","DGREENE","011.44.1346.229268","2007-03-19 00:00:00.0","SA_REP",9500,0.15,147,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (164,"Mattea","Marvins","MMARVINS","011.44.1346.329268","2008-01-24 00:00:00.0","SA_REP",7200,0.1,147,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (165,"David","Lee","DLEE","011.44.1346.529268","2008-02-23 00:00:00.0","SA_REP",6800,0.1,147,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (166,"Sundar","Ande","SANDE","011.44.1346.629268","2008-03-24 00:00:00.0","SA_REP",6400,0.1,147,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (167,"Amit","Banda","ABANDA","011.44.1346.729268","2008-04-21 00:00:00.0","SA_REP",6200,0.1,147,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (168,"Lisa","Ozer","LOZER","011.44.1343.929268","2005-03-11 00:00:00.0","SA_REP",11500,0.25,148,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (169,"Harrison","Bloom","HBLOOM","011.44.1343.829268","2006-03-23 00:00:00.0","SA_REP",10000,0.2,148,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (170,"Tayler","Fox","TFOX","011.44.1343.729268","2006-01-24 00:00:00.0","SA_REP",9600,0.2,148,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (171,"William","Smith","WSMITH","011.44.1343.629268","2007-02-23 00:00:00.0","SA_REP",7400,0.15,148,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (172,"Elizabeth","Bates","EBATES","011.44.1343.529268","2007-03-24 00:00:00.0","SA_REP",7300,0.15,148,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (173,"Sundita","Kumar","SKUMAR","011.44.1343.329268","2008-04-21 00:00:00.0","SA_REP",6100,0.1,148,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (174,"Ellen","Abel","EABEL","011.44.1644.429267","2004-05-11 00:00:00.0","SA_REP",11000,0.3,149,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (175,"Alyssa","Hutton","AHUTTON","011.44.1644.429266","2005-03-19 00:00:00.0","SA_REP",8800,0.25,149,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (176,"Jonathon","Taylor","JTAYLOR","011.44.1644.429265","2006-03-24 00:00:00.0","SA_REP",8600,0.2,149,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (177,"Jack","Livingston","JLIVINGS","011.44.1644.429264","2006-04-23 00:00:00.0","SA_REP",8400,0.2,149,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (178,"Kimberely","Grant","KGRANT","011.44.1644.429263","2007-05-24 00:00:00.0","SA_REP",7000,0.15,149,0 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (179,"Charles","Johnson","CJOHNSON","011.44.1644.429262","2008-01-04 00:00:00.0","SA_REP",6200,0.1,149,80 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (180,"Winston","Taylor","WTAYLOR","650.507.9876","2006-01-24 00:00:00.0","SH_CLERK",3200,0D,120,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (181,"Jean","Fleaur","JFLEAUR","650.507.9877","2006-02-23 00:00:00.0","SH_CLERK",3100,0D,120,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (182,"Martha","Sullivan","MSULLIVA","650.507.9878","2007-06-21 00:00:00.0","SH_CLERK",2500,0D,120,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (183,"Girard","Geoni","GGEONI","650.507.9879","2008-02-03 00:00:00.0","SH_CLERK",2800,0D,120,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (184,"Nandita","Sarchand","NSARCHAN","650.509.1876","2004-01-27 00:00:00.0","SH_CLERK",4200,0D,121,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (185,"Alexis","Bull","ABULL","650.509.2876","2005-02-20 00:00:00.0","SH_CLERK",4100,0D,121,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (186,"Julia","Dellinger","JDELLING","650.509.3876","2006-06-24 00:00:00.0","SH_CLERK",3400,0D,121,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (187,"Anthony","Cabrio","ACABRIO","650.509.4876","2007-02-07 00:00:00.0","SH_CLERK",3000,0D,121,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (188,"Kelly","Chung","KCHUNG","650.505.1876","2005-06-14 00:00:00.0","SH_CLERK",3800,0D,122,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (189,"Jennifer","Dilly","JDILLY","650.505.2876","2005-08-13 00:00:00.0","SH_CLERK",3600,0D,122,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (190,"Timothy","Gates","TGATES","650.505.3876","2006-07-11 00:00:00.0","SH_CLERK",2900,0D,122,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (191,"Randall","Perkins","RPERKINS","650.505.4876","2007-12-19 00:00:00.0","SH_CLERK",2500,0D,122,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (192,"Sarah","Bell","SBELL","650.501.1876","2004-02-04 00:00:00.0","SH_CLERK",4000,0D,123,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (193,"Britney","Everett","BEVERETT","650.501.2876","2005-03-03 00:00:00.0","SH_CLERK",3900,0D,123,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (194,"Samuel","McCain","SMCCAIN","650.501.3876","2006-07-01 00:00:00.0","SH_CLERK",3200,0D,123,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (195,"Vance","Jones","VJONES","650.501.4876","2007-03-17 00:00:00.0","SH_CLERK",2800,0D,123,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (196,"Alana","Walsh","AWALSH","650.507.9811","2006-04-24 00:00:00.0","SH_CLERK",3100,0D,124,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (197,"Kevin","Feeney","KFEENEY","650.507.9822","2006-05-23 00:00:00.0","SH_CLERK",3000,0D,124,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (198,"Donald","OConnell","DOCONNEL","650.507.9833","2007-06-21 00:00:00.0","SH_CLERK",2600,0D,124,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (199,"Douglas","Grant","DGRANT","650.507.9844","2008-01-13 00:00:00.0","SH_CLERK",2600,0D,124,50 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (200,"Jennifer","Whalen","JWHALEN","515.123.4444","2003-09-17 00:00:00.0","AD_ASST",4400,0D,101,10 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (201,"Michael","Hartstein","MHARTSTE","515.123.5555","2004-02-17 00:00:00.0","MK_MAN",13000,0D,100,20 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (202,"Pat","Fay","PFAY","603.123.6666","2005-08-17 00:00:00.0","MK_REP",6000,0D,201,20 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (203,"Susan","Mavris","SMAVRIS","515.123.7777","2002-06-07 00:00:00.0","HR_REP",6500,0D,101,40 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (204,"Hermann","Baer","HBAER","515.123.8888","2002-06-07 00:00:00.0","PR_REP",10000,0D,101,70 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (205,"Shelley","Higgins","SHIGGINS","515.123.8080","2002-06-07 00:00:00.0","AC_MGR",12008,0D,101,110 );
		 employees.put (emp.getEmployeeId(), emp);
		emp = new Employee (206,"William","Gietz","WGIETZ","515.123.8181","2002-06-07 00:00:00.0","AC_ACCOUNT",8300,0D,205,110 );
		 employees.put (emp.getEmployeeId(), emp);

	}


	public Iterable<Employee> getEmployees() {
		return employees.values();
	}

	public Employee getEmployee(int id) {
		return employees.get(id);
	}
	
	public Iterable<Employee> getEmployeesByDepartment(Integer departmentId) {
		List<Employee> employeeList = departmentEmployees.get(departmentId);
		if (employeeList == null)
			employeeList = new ArrayList<Employee>();
		return employeeList;
	}

	public Employee createEmployee(Employee employee) throws Exception {
		if (employee == null)
			throw new Exception("No Employee to add");
		if (employee.getFirstName() == null) {
			throw new Exception("Employee First Name must be set");
		}
		if (employee.getLastName() == null) {
			throw new Exception("Employee Last Name must be set");
		}
		Employee createdEmployee = new Employee (employee);

		for (int i = 1; i < 10000; i++) {
			if (employees.putIfAbsent(i, employee) == null) {
				createdEmployee.setEmployeeId(i);
				addDepartmentEmployee(createdEmployee);
				return createdEmployee;
			}
		}

		throw new Exception("Unable to assign an id to the new department");
	}
	
	public Employee updateEmployee(int employeeId, Employee updateEmployee) throws Exception {
		if (updateEmployee == null)
			throw new Exception("No Employee to update");
	
		if (updateEmployee.getFirstName() == null) {
			throw new Exception("Employee First Name must be set");
		}
		if (updateEmployee.getLastName() == null) {
			throw new Exception("Employee Last Name must be set");
		}
		Employee employee = getEmployee(employeeId);
		removeDepartmentEmployee(employee);
		employee.update (updateEmployee);
		addDepartmentEmployee(employee);
		return employee;
	}
	public Employee deleteEmployee(int id) {
		Employee employee = employees.remove(id);
		if (employee != null) {
			employee.setEmployeeId(0);
			return employee;
		}
		return null;
	}
	

// Manage Department
	private void populateDepartments () throws Exception {
		Department dept;
		dept = new Department (9009,"Demo333",200,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (5005,"myDepartment",200,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (5006,"myDepartment",200,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (4,"raghu-rest",101,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (6,"newdept",101,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (5007,"Demo333",200,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (9,"raghu9",101,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (7,"Raghuedit",200,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (1002,"Test2",101,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (9898,"MyTest",200,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (5008,"Demo333",200,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (5012,"Demo333",200,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (5014,"Demo333",200,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (4141,"Demo",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (10,"DepartmentTest",200,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (20,"Marketing",201,1800);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (30,"Purchasing",114,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (40,"Human Resources",203,2400);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (50,"Shipping",121,1500);
		 departments.put (dept.getDepartmentId(), dept);
		
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (60,"IT",103,1400);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (70,"Public Relations",204,2700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (80,"Sales",145,2500);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (90,"Executive",100,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (100,"Finance",108,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (110,"Accounting",205,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (120,"Treasury",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (130,"Corporate Tax",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (140,"Control And Credit",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (150,"Shareholder Services",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (160,"Benefits",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (170,"Manufacturing",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (180,"Construction",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (190,"Contracting",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (200,"Operations",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (210,"IT Support",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (220,"NOC",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (230,"IT Helpdesk",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (240,"Government Sales",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (250,"Retail Sales",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (260,"Recruiting",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (270,"Payroll",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (5000,"TestMe",200,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (2020,"20Marketing",0,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (333,"Demo333",200,1700);
		 departments.put (dept.getDepartmentId(), dept);

		dept = new Department (11,"11Marketing",0,1700);
		 departments.put (dept.getDepartmentId(), dept);
	}

	public Iterable<Department> getDepartments() {
		return departments.values();
	}
	
	public Department getDepartment(int id) {
		return departments.get(id);
	}

	public Department createDepartment(String name) throws Exception {
		if (name == null) {
			throw new Exception("Department name must be set");
		}

		Department department = new Department();
		department.setDepartmentName(name);
		
		for (int i = 1; i < 10000; i++) {
			if (departments.putIfAbsent(i, department) == null) {
				department.setDepartmentId(i);
				return department;
			}
		}
		throw new Exception("Unable to assign an id to the new department");
	}



	public Department deleteDeparment(int id) {
		Department department = departments.remove(id);
		if (department != null) {
			department.setDepartmentId(0);
			return department;
		}
		return null;
	}
	
	public void setEmployeeDepartment() {
		Iterable<Employee> employees = getEmployees();
		for (Employee e : employees) {
			Department d = getDepartment(e.getDepartmentId());
			if (d != null) {
				e.setDepartment(d);

			}
		}	
	}

// Manage Employees in a department
	public void populateDepartmentEmployees () {	
		Iterable<Employee> employees = getEmployees();
		for (Employee e: employees) {
			addDepartmentEmployee (e);
		}
	}
	
	public void addDepartmentEmployee (Employee employee) {
		List<Employee> employeeList;
		employeeList = departmentEmployees.get(employee.getDepartmentId());
		if (employeeList == null){
			employeeList = new ArrayList<Employee>();
			departmentEmployees.put(employee.getDepartmentId(),employeeList);		
		}
		employeeList.add(employee);
	}
	public void removeDepartmentEmployee (Employee employee) {
		List<Employee> employeeList;
		employeeList = departmentEmployees.get(employee.getDepartmentId());
		if (employeeList != null){
			for (Employee e : employeeList) {
				if (e.getEmployeeId() == employee.getEmployeeId()) {
					employeeList.remove(e);
					break;
				}				
			}
		}

	}
}
